"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.loginUser = void 0;
var aws_sdk_1 = __importDefault(require("aws-sdk"));
var cognitoidentityserviceprovider = new aws_sdk_1.default.CognitoIdentityServiceProvider({
    region: process.env.REGION || 'us-east-1'
});
function loginUser(props) {
    return __awaiter(this, void 0, void 0, function () {
        var params, res, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    params = {
                        AuthFlow: 'ADMIN_NO_SRP_AUTH',
                        ClientId: props.clientId,
                        UserPoolId: props.userPoolId,
                        AuthParameters: {
                            USERNAME: props.userName,
                            PASSWORD: props.password
                        }
                    };
                    return [4, cognitoidentityserviceprovider
                            .adminInitiateAuth(params)
                            .promise()];
                case 1:
                    res = _a.sent();
                    if (res.ChallengeName === 'NEW_PASSWORD_REQUIRED') {
                        return [2, {
                                challenge: 'NEW_PASSWORD',
                                session: res.Session || '',
                                advice: 'Should use loginHandleNewPassword rise function in response'
                            }];
                    }
                    if (res.ChallengeName) {
                        throw new Error('rise foundation does not handle the following challenge: ' +
                            res.ChallengeName);
                    }
                    result = res.AuthenticationResult || {};
                    if (!result.AccessToken || !result.RefreshToken || !result.IdToken) {
                        throw new Error('Unrecognized response from AWS Cognito');
                    }
                    return [2, {
                            accessToken: result.AccessToken,
                            refreshToken: result.RefreshToken,
                            idToken: result.IdToken
                        }];
            }
        });
    });
}
exports.loginUser = loginUser;
