"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeLambdaErrorAlarm = void 0;
function makeLambdaErrorAlarm(config) {
    var _a;
    var cf = {
        Resources: (_a = {},
            _a["Alarm" + config.name + config.stage] = {
                Type: 'AWS::CloudWatch::Alarm',
                Properties: {
                    AlarmName: config.appName + "-" + config.name + "-" + config.stage,
                    AlarmDescription: config.description,
                    MetricName: 'Errors',
                    Namespace: 'AWS/Lambda',
                    Dimensions: [
                        {
                            Name: 'FunctionName',
                            Value: config.functionName
                        }
                    ],
                    Statistic: 'Sum',
                    Period: config.period || 60,
                    EvaluationPeriods: config.evaluationPeriods || 1,
                    Threshold: config.threshold,
                    ComparisonOperator: 'GreaterThanThreshold'
                }
            },
            _a),
        Outputs: {}
    };
    if (config.snsTopic) {
        cf.Resources["Alarm" + config.name + config.stage
        // @ts-ignore
        ].Properties.AlarmActions = [config.snsTopic];
    }
    return cf;
}
exports.makeLambdaErrorAlarm = makeLambdaErrorAlarm;
