"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeEventRule = void 0;
function makeEventRule(_a) {
    var _b;
    var appName = _a.appName, eventBus = _a.eventBus, eventSource = _a.eventSource, eventName = _a.eventName, lambdaName = _a.lambdaName;
    return {
        Resources: (_b = {},
            _b["EventListener" + appName + eventName] = {
                Type: 'AWS::Events::Rule',
                Properties: {
                    EventBusName: eventBus,
                    EventPattern: {
                        source: ["custom." + eventSource],
                        'detail-type': [eventName]
                    },
                    Targets: [
                        {
                            Arn: {
                                'Fn::GetAtt': [lambdaName, 'Arn']
                            },
                            Id: "EventListener" + appName + eventName
                        }
                    ]
                }
            },
            _b["EventRuleRole" + appName + eventName] = {
                Type: 'AWS::Lambda::Permission',
                Properties: {
                    FunctionName: {
                        'Fn::GetAtt': [lambdaName, 'Arn']
                    },
                    Action: 'lambda:InvokeFunction',
                    Principal: 'events.amazonaws.com',
                    SourceArn: {
                        'Fn::GetAtt': [
                            "EventListener" + appName + eventName,
                            'Arn'
                        ]
                    }
                }
            },
            _b),
        Outputs: {}
    };
}
exports.makeEventRule = makeEventRule;
