"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.http = exports.uuid = exports.getPostData = exports.getUserId = void 0;
var aws_js_1 = __importDefault(require("/var/runtime/node_modules/aws-sdk/lib/aws.js"));
var getUserId = function (event) {
    if (!event)
        return null;
    if (!event.requestContext)
        return null;
    if (!event.requestContext.authorizer)
        return null;
    if (!event.requestContext.authorizer.jwt)
        return null;
    if (!event.requestContext.authorizer.jwt.claims)
        return null;
    if (!event.requestContext.authorizer.jwt.claims.sub)
        return null;
    return event.requestContext.authorizer.jwt.claims.sub;
};
exports.getUserId = getUserId;
var getPostData = function (event) {
    return JSON.parse(event.body);
};
exports.getPostData = getPostData;
var uuid = function () { return aws_js_1.default.util.uuid.v4(); };
exports.uuid = uuid;
var headers = {
    'Content-Type': 'application/json',
    'Access-Control-Allow-Origin': '*',
    'Access-Control-Allow-Headers': 'Content-Type,Authorization,authorization',
    'Access-Control-Allow-Methods': 'OPTIONS,PUT,GET,POST'
};
exports.http = {
    success: function (x) { return ({
        statusCode: 200,
        body: JSON.stringify(x),
        headers: headers
    }); },
    validationError: function (message) { return ({
        statusCode: 400,
        body: JSON.stringify({ message: message }),
        headers: headers
    }); },
    serviceError: function (message) { return ({
        statusCode: 500,
        body: JSON.stringify({ message: message }),
        headers: headers
    }); }
};
